use std::collections::HashMap;

use super::CommandTransferValue;

impl From<String> for CommandTransferValue {
    fn from(s: String) -> Self {
        Self::String(s.to_owned())
    }
}
impl From<f64> for CommandTransferValue {
    fn from(s: f64) -> Self {
        Self::Number(s.to_owned())
    }
}
impl From<i64> for CommandTransferValue {
    fn from(s: i64) -> Self {
        Self::Integer(s.to_owned())
    }
}
impl From<HashMap<String, CommandTransferValue>> for CommandTransferValue {
    fn from(s: HashMap<String, CommandTransferValue>) -> Self {
        Self::Table(s.to_owned())
    }
}
impl From<bool> for CommandTransferValue {
    fn from(s: bool) -> Self {
        Self::Boolean(s.to_owned())
    }
}
impl From<()> for CommandTransferValue {
    fn from(_: ()) -> Self {
        Self::Nil
    }
}
