use std::path::PathBuf;

use anyhow::Result;
use cli_log::info;
use tokio::{fs, sync::mpsc::Sender};

use crate::app::events::Event;

pub async fn load(tx: Sender<Event>, path: PathBuf) -> Result<()> {
    let lua_config_code = fs::read_to_string(&path).await?;
    tx.send(Event::LuaCommand(lua_config_code)).await?;
    info!("Loaded config file at `{}`", path.display());
    Ok(())
}
