mod accounts;
mod app;
mod cli;
mod ui;

use clap::Parser;

use crate::cli::{Args, Command};

#[tokio::main]
async fn main() -> anyhow::Result<()> {
    cli_log::init_cli_log!();

    let args = Args::parse();
    let command = args.subcommand.unwrap_or(Command::Start {});
    match command {
        Command::Start {} => {
            let mut app = app::App::new()?;

            // NOTE(@soispha): The `None` is temporary <2024-05-03>
            app.run(None, args.plugin_path).await?;
        }
    };

    Ok(())
}

// FIXME(@soispha): Re-exports for trixy, this should be configurable <2024-05-03>
pub use crate::app::command_interface::*;
